/*  $Id: config.h,v 1.44 2003/05/24 01:56:02 dm Exp $

    This file is part of the

    GRammar vISUalization tool (GRISU)

    Developed by Holger Wunsch and Detmar Meurers
    Copyright (C) 1998-2003 by the developers
    All rights reserved

    Seminar fr Sprachwissenschaft, Universitt Tbingen and
    Department of Linguistics, The Ohio State University

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/

/**
   @file

   This file contains all version information strings.

   @author Holger Wunsch */


#ifndef __CONFIG_H_
#define __CONFIG_H_

/** The current version. */
#define GRISU_VERSION "1.3.12"

/** The application name, shown on the title bar of the main window. */
#define APP_NAME "Grisu"

/** The about string.<br>
    The %s in this string marks the position where GRISU_VERSION is to be inserted. */
#define GRISU_ABOUT_STRING \
  "GRammar vISUalization tool (GRISU)\n\n"\
  "Version %s\n\n"\
  "Developed by Holger Wunsch and Detmar Meurers\n"\
  "Copyright (C) 1998-2003 by the developers\n"\
  "All rights reserved\n\n"\
  "Seminar fr Sprachwissenschaft, Universitt Tbingen and\n"\
  "Department of Linguistics, The Ohio State University"

#endif
