/* A Bison parser, made from il.y, by GNU bison 1.75.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON	1

/* Pure parsers.  */
#define YYPURE	1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     STRING = 258,
     ATOM = 259,
     INTEGER = 260,
     NEWDATA = 261,
     NEWDATA_TREE = 262,
     NEWDATA_STRUCTURE = 263,
     STRUC_MARKER = 264,
     TREE_MARKER = 265,
     REENT_MARKER = 266,
     FEATVAL_MARKER = 267,
     LIST_MARKER = 268,
     SET_MARKER = 269,
     FUNCTION_MARKER = 270,
     REL_MARKER = 271,
     ATOM_MARKER = 272,
     TAIL_MARKER = 273,
     REST_MARKER = 274,
     DISJUNCTION_MARKER = 275,
     CONJUNCTION_MARKER = 276,
     LEFT_PAREN = 277,
     RIGHT_PAREN = 278,
     SLASH = 279,
     HASH = 280,
     HIDDEN_FLAG = 281,
     DIFFERENT_FLAG = 282,
     STRIKEOUT_FLAG = 283,
     MULTILINE_FLAG = 284,
     EXPANDED_FLAG = 285,
     ERROR = 286
   };
#endif
#define STRING 258
#define ATOM 259
#define INTEGER 260
#define NEWDATA 261
#define NEWDATA_TREE 262
#define NEWDATA_STRUCTURE 263
#define STRUC_MARKER 264
#define TREE_MARKER 265
#define REENT_MARKER 266
#define FEATVAL_MARKER 267
#define LIST_MARKER 268
#define SET_MARKER 269
#define FUNCTION_MARKER 270
#define REL_MARKER 271
#define ATOM_MARKER 272
#define TAIL_MARKER 273
#define REST_MARKER 274
#define DISJUNCTION_MARKER 275
#define CONJUNCTION_MARKER 276
#define LEFT_PAREN 277
#define RIGHT_PAREN 278
#define SLASH 279
#define HASH 280
#define HIDDEN_FLAG 281
#define DIFFERENT_FLAG 282
#define STRIKEOUT_FLAG 283
#define MULTILINE_FLAG 284
#define EXPANDED_FLAG 285
#define ERROR 286




/* Copy the first part of user declarations.  */
#line 33 "il.y"

  #include <stdio.h>
  #include <stdlib.h>
  #include <kmessagebox.h>
  #include "node.h"

  #include "dataparser.h"
  

#define  YYERROR_VERBOSE 1
#define  YYDEBUG 1
#define  YYPARSE_PARAM arg
#define  YYLEX_PARAM arg

 int yyerror(char* s); 

 extern int curLoc;

 /* Twice the default stack size to avoid stack overflow errors when parsing large data packages. */
#define YYMAXDEPTH 20000

#define YYINITDEPTH 200



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#ifndef YYSTYPE
#line 58 "il.y"
typedef union {
  char* string_type;
  int int_type;
  GenericNode* generic_node_type;
  TypeNode* type_node_type;
  StrucNode* struc_node_type;
  FeatvalNode* featval_node_type;
  ListNode* list_node_type;
  SetNode* set_node_type;
  FunctionNode* function_node_type;
  RelationNode* rel_node_type;
  RefNode* ref_node_type;
  ReentNode* reent_node_type;
  TreeNode* tree_node_type;
  AtomNode* atom_node_type;
  TailNode* tail_node_type;
  RestNode* rest_node_type;
  DisjunctionNode* disjunction_node_type;
  ConjunctionNode* conjunction_node_type;
  List* list_type;
} yystype;
/* Line 193 of /opt/gnu/share/bison/yacc.c.  */
#line 182 "il.cpp"
# define YYSTYPE yystype
# define YYSTYPE_IS_TRIVIAL 1
#endif

#ifndef YYLTYPE
typedef struct yyltype
{
  int first_line;
  int first_column;
  int last_line;
  int last_column;
} yyltype;
# define YYLTYPE yyltype
# define YYLTYPE_IS_TRIVIAL 1
#endif

/* Copy the second part of user declarations.  */
#line 80 "il.y"

  int yylex(YYSTYPE*, void*);
  

/* Line 213 of /opt/gnu/share/bison/yacc.c.  */
#line 206 "il.cpp"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYLTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAX (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAX)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];	\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAX;	\
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  6
#define YYLAST   139

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  32
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  33
/* YYNRULES -- Number of rules. */
#define YYNRULES  58
/* YYNRULES -- Number of states. */
#define YYNSTATES  138

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   286

#define YYTRANSLATE(X) \
  ((unsigned)(X) <= YYMAXUTOK ? yytranslate[X] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned char yyprhs[] =
{
       0,     0,     3,     7,     9,    11,    13,    15,    18,    20,
      22,    24,    25,    28,    30,    32,    34,    36,    38,    40,
      42,    44,    46,    47,    50,    60,    68,    76,    77,    80,
      88,    95,   104,   113,   121,   122,   129,   137,   138,   145,
     154,   162,   168,   175,   182,   184,   186,   188,   190,   191,
     193,   196,   197,   199,   201,   203,   205,   207,   209
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      33,     0,    -1,    34,    58,    35,    -1,     6,    -1,     7,
      -1,     8,    -1,    36,    -1,    35,    36,    -1,    38,    -1,
      41,    -1,    40,    -1,    -1,    37,    38,    -1,    42,    -1,
      54,    -1,    51,    -1,    52,    -1,    47,    -1,    49,    -1,
      55,    -1,    45,    -1,    46,    -1,    -1,    39,    40,    -1,
      22,    10,    61,    63,    59,    60,    64,    39,    23,    -1,
      22,    11,    61,    63,     5,    38,    23,    -1,    22,     9,
      61,    63,    53,    43,    23,    -1,    -1,    44,    43,    -1,
      22,    12,    61,    63,    56,    38,    23,    -1,    22,    12,
      61,    63,    56,    23,    -1,    22,    20,    61,    63,    38,
      38,    37,    23,    -1,    22,    21,    61,    63,    38,    38,
      37,    23,    -1,    22,    13,    61,    63,    37,    48,    23,
      -1,    -1,    22,    18,    61,    63,    38,    23,    -1,    22,
      14,    61,    63,    37,    50,    23,    -1,    -1,    22,    19,
      61,    63,    38,    23,    -1,    22,    15,    61,    63,    53,
      57,    37,    23,    -1,    22,    16,    61,    63,    57,    37,
      23,    -1,    22,    61,    63,     3,    23,    -1,    22,    25,
      61,    63,     5,    23,    -1,    22,    17,    61,    63,     3,
      23,    -1,     3,    -1,     3,    -1,     3,    -1,     3,    -1,
      -1,     3,    -1,    62,    61,    -1,    -1,    26,    -1,    27,
      -1,    28,    -1,    29,    -1,    30,    -1,     5,    -1,     5,
      -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned char yyrline[] =
{
       0,   157,   157,   159,   159,   160,   163,   163,   165,   165,
     166,   169,   169,   170,   170,   171,   172,   173,   174,   175,
     176,   177,   180,   180,   182,   184,   186,   188,   188,   189,
     189,   192,   194,   196,   198,   198,   200,   202,   202,   204,
     206,   208,   210,   212,   214,   216,   218,   220,   222,   222,
     225,   225,   228,   228,   229,   230,   231,   234,   236
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "STRING", "ATOM", "INTEGER", "NEWDATA", 
  "NEWDATA_TREE", "NEWDATA_STRUCTURE", "STRUC_MARKER", "TREE_MARKER", 
  "REENT_MARKER", "FEATVAL_MARKER", "LIST_MARKER", "SET_MARKER", 
  "FUNCTION_MARKER", "REL_MARKER", "ATOM_MARKER", "TAIL_MARKER", 
  "REST_MARKER", "DISJUNCTION_MARKER", "CONJUNCTION_MARKER", "LEFT_PAREN", 
  "RIGHT_PAREN", "SLASH", "HASH", "HIDDEN_FLAG", "DIFFERENT_FLAG", 
  "STRIKEOUT_FLAG", "MULTILINE_FLAG", "EXPANDED_FLAG", "ERROR", "$accept", 
  "datapackage", "newdata", "structures", "structure", "structs", 
  "struct", "trees", "tree", "reentr", "struc", "featvals", "featval", 
  "disjunction", "conjunction", "list", "tail", "set", "rest", "function", 
  "relation", "type", "ref", "any", "feature", "functor", "windowtitle", 
  "label", "arclabel", "flags", "flag", "id", "linkid", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    32,    33,    34,    34,    34,    35,    35,    36,    36,
      36,    37,    37,    38,    38,    38,    38,    38,    38,    38,
      38,    38,    39,    39,    40,    41,    42,    43,    43,    44,
      44,    45,    46,    47,    48,    48,    49,    50,    50,    51,
      52,    53,    54,    55,    56,    57,    58,    59,    60,    60,
      61,    61,    62,    62,    62,    62,    62,    63,    64
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     3,     1,     1,     1,     1,     2,     1,     1,
       1,     0,     2,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     0,     2,     9,     7,     7,     0,     2,     7,
       6,     8,     8,     7,     0,     6,     7,     0,     6,     8,
       7,     5,     6,     6,     1,     1,     1,     1,     0,     1,
       2,     0,     1,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       0,     3,     4,     5,     0,     0,     1,    46,     0,     0,
       2,     6,     8,    10,     9,    13,    20,    21,    17,    18,
      15,    16,    14,    19,    51,    51,    51,    51,    51,    51,
      51,    51,    51,    51,    51,     7,    52,    53,    54,    55,
      56,     0,    51,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    57,     0,    50,     0,     0,    11,    11,
       0,     0,     0,     0,     0,     0,    51,    27,    47,    48,
       0,    34,    37,     0,    45,    11,     0,     0,     0,     0,
       0,     0,     0,     0,    27,    49,     0,     0,     0,    12,
       0,     0,     0,    11,     0,    43,    11,    11,    42,     0,
      51,    26,    28,    58,    22,    25,    51,    33,    51,    36,
       0,    40,     0,     0,     0,     0,     0,     0,     0,    39,
      31,    32,    41,     0,     0,    24,    23,     0,     0,    44,
       0,     0,     0,    30,     0,    35,    38,    29
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     4,     5,    10,    11,    71,    89,   116,    13,    14,
      15,    83,    84,    16,    17,    18,    90,    19,    92,    20,
      21,    67,    22,    23,   130,    75,     8,    69,    86,    41,
      42,    54,   104
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -59
static const yysigned_char yypact[] =
{
       7,   -59,   -59,   -59,    16,    18,   -59,   -59,    12,    32,
      12,   -59,   -59,   -59,   -59,   -59,   -59,   -59,   -59,   -59,
     -59,   -59,   -59,   -59,    37,    37,    37,    37,    37,    37,
      37,    37,    37,    37,    37,   -59,   -59,   -59,   -59,   -59,
     -59,    35,    37,    35,    35,    35,    35,    35,    35,    35,
      35,    35,    35,   -59,    39,   -59,    51,    63,   -59,   -59,
      39,    69,    79,    61,    61,    84,    37,    68,   -59,    88,
      61,    70,    71,    69,   -59,   -59,    75,   112,    61,    61,
      82,    35,    96,    87,    68,   -59,   104,    89,    86,   -59,
      90,    60,    91,   -59,    -4,   -59,   -59,   -59,   -59,   113,
      37,   -59,   -59,   -59,   -59,   -59,    37,   -59,    37,   -59,
      10,   -59,    14,    28,    92,    35,    36,    35,    35,   -59,
     -59,   -59,   -59,   114,   108,   -59,   -59,    61,    61,   -59,
      65,   100,   101,   -59,   107,   -59,   -59,   -59
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -59,   -59,   -59,   -59,   121,   -58,    -8,   -59,    19,   -59,
     -59,    50,   -59,   -59,   -59,   -59,   -59,   -59,   -59,   -59,
     -59,    76,   -59,   -59,   -59,    66,   -59,   -59,   -59,   -22,
     -59,   -21,   -59
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, parse error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      12,    72,    12,    43,    44,    45,    46,    47,    48,    49,
      50,    51,    52,     1,     2,     3,     6,    94,    77,   111,
      55,     7,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    77,   119,     9,   110,    77,   120,   112,   113,
      53,    24,    25,    26,    81,    27,    28,    29,    30,    31,
      77,   121,    32,    33,    68,    78,    79,    34,   124,   125,
      99,    66,    87,    36,    37,    38,    39,    40,    70,    24,
      96,    97,    74,    27,    28,    29,    30,    31,   115,   108,
      32,    33,    76,    77,   117,    34,   118,    77,   133,    80,
      82,    85,    88,    91,   123,    24,   127,   128,    95,    27,
      28,    29,    30,    31,   106,    98,    32,    33,   100,   103,
     101,    34,   105,   107,   109,   122,   114,   129,    25,   131,
     132,    24,   134,   135,   136,    27,    28,    29,    30,    31,
     137,    35,    32,    33,   102,   126,    73,    34,     0,    93
};

static const short yycheck[] =
{
       8,    59,    10,    25,    26,    27,    28,    29,    30,    31,
      32,    33,    34,     6,     7,     8,     0,    75,    22,    23,
      42,     3,    43,    44,    45,    46,    47,    48,    49,    50,
      51,    52,    22,    23,    22,    93,    22,    23,    96,    97,
       5,     9,    10,    11,    66,    13,    14,    15,    16,    17,
      22,    23,    20,    21,     3,    63,    64,    25,    22,    23,
      81,    22,    70,    26,    27,    28,    29,    30,     5,     9,
      78,    79,     3,    13,    14,    15,    16,    17,   100,    19,
      20,    21,     3,    22,   106,    25,   108,    22,    23,     5,
      22,     3,    22,    22,   115,     9,   117,   118,    23,    13,
      14,    15,    16,    17,    18,    23,    20,    21,    12,     5,
      23,    25,    23,    23,    23,    23,     3,     3,    10,   127,
     128,     9,   130,    23,    23,    13,    14,    15,    16,    17,
      23,    10,    20,    21,    84,   116,    60,    25,    -1,    73
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,     6,     7,     8,    33,    34,     0,     3,    58,    22,
      35,    36,    38,    40,    41,    42,    45,    46,    47,    49,
      51,    52,    54,    55,     9,    10,    11,    13,    14,    15,
      16,    17,    20,    21,    25,    36,    26,    27,    28,    29,
      30,    61,    62,    61,    61,    61,    61,    61,    61,    61,
      61,    61,    61,     5,    63,    61,    63,    63,    63,    63,
      63,    63,    63,    63,    63,    63,    22,    53,     3,    59,
       5,    37,    37,    53,     3,    57,     3,    22,    38,    38,
       5,    61,    22,    43,    44,     3,    60,    38,    22,    38,
      48,    22,    50,    57,    37,    23,    38,    38,    23,    63,
      12,    23,    43,     5,    64,    23,    18,    23,    19,    23,
      37,    23,    37,    37,     3,    61,    39,    61,    61,    23,
      23,    23,    23,    63,    22,    23,    40,    63,    63,     3,
      56,    38,    38,    23,    38,    23,    23,    23
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1

/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");			\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)           \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX	yylex (&yylval, YYLEX_PARAM)
#else
# define YYLEX	yylex (&yylval)
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)
# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)
/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
#endif /* !YYDEBUG */

/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*-----------------------------.
| Print this symbol on YYOUT.  |
`-----------------------------*/

static void
#if defined (__STDC__) || defined (__cplusplus)
yysymprint (FILE* yyout, int yytype, YYSTYPE yyvalue)
#else
yysymprint (yyout, yytype, yyvalue)
    FILE* yyout;
    int yytype;
    YYSTYPE yyvalue;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvalue;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyout, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyout, yytoknum[yytype], yyvalue);
# endif
    }
  else
    YYFPRINTF (yyout, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyout, ")");
}
#endif /* YYDEBUG. */


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
#if defined (__STDC__) || defined (__cplusplus)
yydestruct (int yytype, YYSTYPE yyvalue)
#else
yydestruct (yytype, yyvalue)
    int yytype;
    YYSTYPE yyvalue;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvalue;

  switch (yytype)
    {
      default:
        break;
    }
}



/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
#  define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL
# else
#  define YYPARSE_PARAM_ARG YYPARSE_PARAM
#  define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
# endif
#else /* !YYPARSE_PARAM */
# define YYPARSE_PARAM_ARG
# define YYPARSE_PARAM_DECL
#endif /* !YYPARSE_PARAM */

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
# ifdef YYPARSE_PARAM
int yyparse (void *);
# else
int yyparse (void);
# endif
#endif




int
yyparse (YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  /* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of parse errors so far.  */
int yynerrs;

  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yychar1 = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with.  */

  if (yychar <= 0)		/* This means end of input.  */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more.  */

      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yychar1 = YYTRANSLATE (yychar);

      /* We have to keep this `#if YYDEBUG', since we use variables
	 which are defined only if `YYDEBUG' is set.  */
      YYDPRINTF ((stderr, "Next token is "));
      YYDSYMPRINT ((stderr, yychar1, yylval));
      YYDPRINTF ((stderr, "\n"));
    }

  /* If the proper action on seeing token YYCHAR1 is to reduce or to
     detect an error, take that action.  */
  yyn += yychar1;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yychar1)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %d (%s), ",
	      yychar, yytname[yychar1]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];



#if YYDEBUG
  /* We have to keep this `#if YYDEBUG', since we use variables which
     are defined only if `YYDEBUG' is set.  */
  if (yydebug)
    {
      int yyi;

      YYFPRINTF (stderr, "Reducing via rule %d (line %d), ",
		 yyn - 1, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (yyi = yyprhs[yyn]; yyrhs[yyi] >= 0; yyi++)
	YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
      YYFPRINTF (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif
  switch (yyn)
    {
        case 2:
#line 157 "il.y"
    {yyval.list_type = yyvsp[0].list_type; ((ParserArgs*) arg)->parsedData = yyval.list_type; strcpy(((ParserArgs*) arg)->windowtitle, yyvsp[-1].string_type); ((ParserArgs*) arg)->showDefault = yyvsp[-2].int_type;}
    break;

  case 3:
#line 159 "il.y"
    {yyval.int_type = 0;}
    break;

  case 4:
#line 160 "il.y"
    {yyval.int_type = DRAW_TREE;}
    break;

  case 5:
#line 161 "il.y"
    {yyval.int_type = DRAW_STRUC;}
    break;

  case 6:
#line 163 "il.y"
    {yyval.list_type = prepend(yyvsp[0].generic_node_type, NULL);}
    break;

  case 7:
#line 164 "il.y"
    {yyval.list_type = append(yyvsp[-1].list_type, yyvsp[0].generic_node_type);}
    break;

  case 8:
#line 165 "il.y"
    {yyval.generic_node_type = (GenericNode*) yyvsp[0].generic_node_type;}
    break;

  case 9:
#line 166 "il.y"
    {yyval.generic_node_type = (GenericNode*) yyvsp[0].reent_node_type;}
    break;

  case 10:
#line 167 "il.y"
    {yyval.generic_node_type = (GenericNode*) yyvsp[0].tree_node_type;}
    break;

  case 11:
#line 169 "il.y"
    {yyval.list_type = NULL;}
    break;

  case 12:
#line 169 "il.y"
    {yyval.list_type = append(yyvsp[-1].list_type, (GenericNode*) yyvsp[0].generic_node_type);}
    break;

  case 13:
#line 170 "il.y"
    {yyval.generic_node_type = (GenericNode*) yyvsp[0].struc_node_type;}
    break;

  case 14:
#line 171 "il.y"
    {yyval.generic_node_type = (GenericNode*) yyvsp[0].ref_node_type;}
    break;

  case 15:
#line 172 "il.y"
    {yyval.generic_node_type = (GenericNode*) yyvsp[0].function_node_type;}
    break;

  case 16:
#line 173 "il.y"
    {yyval.generic_node_type = (GenericNode*) yyvsp[0].rel_node_type;}
    break;

  case 17:
#line 174 "il.y"
    {yyval.generic_node_type = (GenericNode*) yyvsp[0].list_node_type;}
    break;

  case 18:
#line 175 "il.y"
    {yyval.generic_node_type = (GenericNode*) yyvsp[0].set_node_type;}
    break;

  case 19:
#line 176 "il.y"
    {yyval.generic_node_type = (GenericNode*) yyvsp[0].atom_node_type;}
    break;

  case 20:
#line 177 "il.y"
    {yyval.generic_node_type = yyvsp[0].disjunction_node_type; }
    break;

  case 21:
#line 178 "il.y"
    {yyval.generic_node_type = yyvsp[0].conjunction_node_type; }
    break;

  case 22:
#line 180 "il.y"
    {yyval.list_type = NULL;}
    break;

  case 23:
#line 181 "il.y"
    {yyval.list_type = append(yyvsp[-1].list_type, (GenericNode*) yyvsp[0].tree_node_type);}
    break;

  case 24:
#line 182 "il.y"
    {yyval.tree_node_type = createTree(yyvsp[-6].int_type, yyvsp[-5].int_type, yyvsp[-4].string_type, yyvsp[-3].string_type, yyvsp[-2].int_type, yyvsp[-1].list_type); ((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.tree_node_type, yyvsp[-5].int_type);}
    break;

  case 25:
#line 184 "il.y"
    {yyval.reent_node_type = createReent(yyvsp[-4].int_type, yyvsp[-3].int_type, yyvsp[-2].int_type, yyvsp[-1].generic_node_type); ((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.reent_node_type, yyvsp[-3].int_type);}
    break;

  case 26:
#line 186 "il.y"
    {yyval.struc_node_type = createStruc(yyvsp[-4].int_type, yyvsp[-3].int_type, yyvsp[-2].type_node_type, yyvsp[-1].list_type); ((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.struc_node_type, yyvsp[-3].int_type);}
    break;

  case 27:
#line 188 "il.y"
    {yyval.list_type = NULL;}
    break;

  case 28:
#line 188 "il.y"
    {yyval.list_type = prepend((GenericNode*) yyvsp[-1].featval_node_type, yyvsp[0].list_type);}
    break;

  case 29:
#line 189 "il.y"
    {yyval.featval_node_type = createFeatval(yyvsp[-4].int_type, yyvsp[-3].int_type, yyvsp[-2].string_type, yyvsp[-1].generic_node_type);((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.featval_node_type, yyvsp[-3].int_type);}
    break;

  case 30:
#line 190 "il.y"
    {yyval.featval_node_type = createFeatval(yyvsp[-3].int_type, yyvsp[-2].int_type, yyvsp[-1].string_type, NULL); ((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.featval_node_type, yyvsp[-2].int_type);}
    break;

  case 31:
#line 192 "il.y"
    {yyval.disjunction_node_type = createDisjunction(yyvsp[-5].int_type, yyvsp[-4].int_type, prepend(yyvsp[-3].generic_node_type, prepend(yyvsp[-2].generic_node_type, yyvsp[-1].list_type))); ((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.disjunction_node_type, yyvsp[-4].int_type);}
    break;

  case 32:
#line 194 "il.y"
    {yyval.conjunction_node_type = createConjunction(yyvsp[-5].int_type, yyvsp[-4].int_type, prepend(yyvsp[-3].generic_node_type, prepend(yyvsp[-2].generic_node_type, yyvsp[-1].list_type))); ((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.conjunction_node_type, yyvsp[-4].int_type);}
    break;

  case 33:
#line 196 "il.y"
    {yyval.list_node_type = createList(yyvsp[-4].int_type, yyvsp[-3].int_type, yyvsp[-2].list_type, yyvsp[-1].tail_node_type); ((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.list_node_type, yyvsp[-3].int_type);}
    break;

  case 34:
#line 198 "il.y"
    {yyval.tail_node_type = NULL;}
    break;

  case 35:
#line 198 "il.y"
    {yyval.tail_node_type = createTail(yyvsp[-3].int_type, yyvsp[-2].int_type, yyvsp[-1].generic_node_type); ((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.tail_node_type, yyvsp[-2].int_type);}
    break;

  case 36:
#line 200 "il.y"
    {yyval.set_node_type = createSet(yyvsp[-4].int_type, yyvsp[-3].int_type, yyvsp[-2].list_type, yyvsp[-1].rest_node_type); ((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.set_node_type, yyvsp[-3].int_type);}
    break;

  case 37:
#line 202 "il.y"
    {yyval.rest_node_type = NULL;}
    break;

  case 38:
#line 202 "il.y"
    {yyval.rest_node_type = createRest(yyvsp[-3].int_type, yyvsp[-2].int_type, yyvsp[-1].generic_node_type); ((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.rest_node_type, yyvsp[-2].int_type);}
    break;

  case 39:
#line 204 "il.y"
    {yyval.function_node_type = createFunction(yyvsp[-5].int_type, yyvsp[-4].int_type, yyvsp[-3].type_node_type, yyvsp[-2].string_type, yyvsp[-1].list_type); ((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.function_node_type, yyvsp[-4].int_type);}
    break;

  case 40:
#line 206 "il.y"
    {yyval.rel_node_type = createRelation(yyvsp[-4].int_type, yyvsp[-3].int_type, yyvsp[-2].string_type, yyvsp[-1].list_type); ((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.rel_node_type, yyvsp[-3].int_type);}
    break;

  case 41:
#line 208 "il.y"
    {yyval.type_node_type = createType(yyvsp[-3].int_type, yyvsp[-2].int_type, yyvsp[-1].string_type); ((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.type_node_type, yyvsp[-2].int_type);}
    break;

  case 42:
#line 210 "il.y"
    {yyval.ref_node_type = createRef(yyvsp[-3].int_type, yyvsp[-2].int_type, yyvsp[-1].int_type); ((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.ref_node_type, yyvsp[-2].int_type);}
    break;

  case 43:
#line 212 "il.y"
    {yyval.atom_node_type = createAtom(yyvsp[-3].int_type, yyvsp[-2].int_type, yyvsp[-1].string_type); ((ParserArgs*) arg)->map = addToMap(((ParserArgs*) arg)->map, (GenericNode*) yyval.atom_node_type, yyvsp[-2].int_type);}
    break;

  case 44:
#line 214 "il.y"
    {yyval.string_type = yyvsp[0].string_type;}
    break;

  case 45:
#line 216 "il.y"
    {yyval.string_type = yyvsp[0].string_type;}
    break;

  case 48:
#line 222 "il.y"
    {yyval.string_type = NULL;}
    break;

  case 49:
#line 223 "il.y"
    {yyval.string_type = yyvsp[0].string_type;}
    break;

  case 50:
#line 225 "il.y"
    {yyval.int_type = yyvsp[-1].int_type | yyvsp[0].int_type;}
    break;

  case 51:
#line 226 "il.y"
    {yyval.int_type = 0;}
    break;

  case 52:
#line 228 "il.y"
    {yyval.int_type = NODEFLAG_HIDDEN;}
    break;

  case 53:
#line 229 "il.y"
    {yyval.int_type = NODEFLAG_DIFFERENT;}
    break;

  case 54:
#line 230 "il.y"
    {yyval.int_type = NODEFLAG_STRIKEOUT;}
    break;

  case 55:
#line 231 "il.y"
    {yyval.int_type = NODEFLAG_MULTILINE;}
    break;

  case 56:
#line 232 "il.y"
    {yyval.int_type = NODEFLAG_EXPANDED;}
    break;


    }

/* Line 1016 of /opt/gnu/share/bison/yacc.c.  */
#line 1403 "il.cpp"

  yyvsp -= yylen;
  yyssp -= yylen;


#if YYDEBUG
  if (yydebug)
    {
      short *yyssp1 = yyss - 1;
      YYFPRINTF (stderr, "state stack now");
      while (yyssp1 != yyssp)
	YYFPRINTF (stderr, " %d", *++yyssp1);
      YYFPRINTF (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("parse error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "parse error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("parse error");
    }
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyssp > yyss)
	    {
	      YYDPRINTF ((stderr, "Error: popping "));
	      YYDSYMPRINT ((stderr,
			    yystos[*yyssp],
			    *yyvsp));
	      YYDPRINTF ((stderr, "\n"));
	      yydestruct (yystos[*yyssp], *yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDPRINTF ((stderr, "Discarding token %d (%s).\n",
		  yychar, yytname[yychar1]));
      yydestruct (yychar1, yylval);
      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */

  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDPRINTF ((stderr, "Error: popping "));
      YYDSYMPRINT ((stderr,
		    yystos[*yyssp], *yyvsp));
      YYDPRINTF ((stderr, "\n"));

      yydestruct (yystos[yystate], *yyvsp);
      yyvsp--;
      yystate = *--yyssp;


#if YYDEBUG
      if (yydebug)
	{
	  short *yyssp1 = yyss - 1;
	  YYFPRINTF (stderr, "Error: state stack now");
	  while (yyssp1 != yyssp)
	    YYFPRINTF (stderr, " %d", *++yyssp1);
	  YYFPRINTF (stderr, "\n");
	}
#endif
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 241 "il.y"


int yyerror(char *s) {
  char buf[500];
  sprintf(buf, "The input data is corrupt.\nThe error message generated by the parser is:\n%s\nPosition: %d", s, curLoc);
  KMessageBox::error(NULL, buf, "Parse Error", false);
  return 0;
}


